/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.accessor.reference;


/**
 * Optional, Union or Variant value
 * "value/"
 */
public class OptionalValueReference extends AccessorReference {

	public static final OptionalValueReference instance = new OptionalValueReference();

	
	public OptionalValueReference() {
	}
	
	public OptionalValueReference(AccessorReference child) {
		super(child);
	}	
	
	@Override
	public String toString(boolean labelReference) {
		return "o";
	}
	
	@Override
	public AccessorReference clone() {
		return new OptionalValueReference(childReference==null ? null : childReference.clone());
	}	

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof OptionalValueReference == false) return false;
		OptionalValueReference other = (OptionalValueReference) obj;
		if (other.hasChildReference() != hasChildReference()) return false;
		if (hasChildReference() && !other.childReference.equals(childReference)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		int hash = -4238882;
		if (hasChildReference()) hash = 31*hash + childReference.hashCode();		
		return hash;
	}		
	
}

