/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.accessor.reference;


/**
 * A reference to the component value of union type regardless of tag.
 * 
 * "uv"
 */
public class TagReference extends AccessorReference {

	public TagReference() {
	}
	
	public TagReference(AccessorReference child) {
		super(child);
	}

	@Override
	public String toString(boolean labelReference) {
		return "uv";
	}
	
	@Override
	public AccessorReference clone() {
		return new TagReference(childReference==null ? null : childReference.clone());
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof TagReference == false) return false;
		TagReference other = (TagReference) obj;
		if (other.hasChildReference() != hasChildReference()) return false;
		if (hasChildReference() && !other.childReference.equals(childReference)) return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		int hash = -238882;
		if (hasChildReference()) hash = 31*hash + childReference.hashCode();		
		return hash;
	}	
}

