/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.adapter;

import org.simantics.databoard.binding.Binding;

public class BindingPair {

	Binding domain;
	Binding range;
	
	public BindingPair(Binding domain, Binding range)
	{
		if (domain==null||range==null) throw new IllegalArgumentException("null arg");
		this.domain = domain;
		this.range = range;
	}
	
	public Binding getDomain() {
		return domain;
	}
	
	public Binding getRange() {
		return range;
	}

	@Override
	public int hashCode() {
        return domain.hashCode() + 31*range.hashCode();
	}
	
	@Override
	public boolean equals(Object obj) {
        if (obj == null) return false;
        if (!(obj.getClass().equals(this.getClass()))) return false;
        BindingPair other = (BindingPair) obj;
        return objectEquals(other.domain, domain) && objectEquals(other.range, range);
	}
	
    private static boolean objectEquals(Object o1, Object o2) {
        if (o1==o2) return true;
        if (o1==null && o2==null) return true;
        if (o1==null || o2==null) return false;
        return o1.equals(o2);
    }
	
}

