/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.type;

import java.util.Set;

import org.simantics.databoard.util.IdentityPair;


public class BooleanType extends DataType {
	
	public static final BooleanType INSTANCE = new BooleanType();
	
	public BooleanType() {}
		
	@Override
	public boolean equals(Object obj) {
		return obj instanceof BooleanType;
	}
	
	@Override
	public int hashCode() {
		return 0x43673453;
	}    

	@Override
	public void accept(Visitor1 v, Object obj) {
	    v.visit(this, obj);        
	}

	@Override
	public <T> T accept(Visitor<T> v) {
	    return v.visit(this);
	}

	@Override
	protected boolean deepEquals(Object obj,
			Set<IdentityPair<DataType, DataType>> compareHistory) {
		return obj instanceof BooleanType;
	}
		
}
