/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.util.binary;

import java.io.IOException;

public interface Seekable {

	/**
	 * Seek new position. The next value will be written after the index of 
	 * the given pointer.
	 *  
	 * @param newPosition new position
	 */
	void position(long newPosition) throws IOException; 

	/**
	 * Get position
	 * 
	 * @return position
	 * @throws IOException
	 */
	long position() throws IOException;
	
}

